//---------------------------------------------------------------------------
//
// Name:        Project1Frm.h
// Author:      Rocco84
// Created:     25/02/2006 19.00.33
// Description: classi frame principale e frame figlio
//              Il frame figlio  legato al frame padre
//---------------------------------------------------------------------------

#ifndef __Frame_Principale_h__
#define __Frame_Principale_h__

#ifdef __BORLANDC__
	#pragma hdrstop
#endif

#ifndef WX_PRECOMP
	#include <wx/wx.h>
	#include <wx/frame.h>
#else
	#include <wx/wxprec.h>
#endif

//Do not add custom headers
//wxDev-C++ designer will remove them
////Header Include Start
#include <wx/textctrl.h>
#include <wx/button.h>
#include <sstream> 
////Header Include End

////Dialog Style Start
#undef Frame_Principale_STYLE
#define Frame_Principale_STYLE wxCAPTION | wxRESIZE_BORDER | wxSYSTEM_MENU | wxTHICK_FRAME | wxMINIMIZE_BOX | wxMAXIMIZE_BOX | wxCLOSE_BOX
////Dialog Style End

class Frame_Principale : public wxFrame
{
	private:
		DECLARE_EVENT_TABLE();
	
	    //std::string numero1; 
        //std::string numero2;  
        double b, c;
    public:
		Frame_Principale(wxWindow *parent, wxWindowID id = 1, const wxString &title = wxT("Project1"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = Frame_Principale_STYLE);
		virtual ~Frame_Principale();
		
	public:
		//Do not add custom control declarations
		//wxDev-C++ will remove them. Add custom code after the block.
		////GUI Control Declaration Start
		wxTextCtrl *Lunghezza;
		wxTextCtrl *Larghezza;
        wxTextCtrl *Risultato;
		wxButton *Calcola_Operazioni;
		wxButton *WxButton_clear;
		wxStaticText *WxStaticText1;
        wxButton *WxButton_Save;
        wxButton *WxButton_Print;
        wxButton *WxButton_Esci;
        wxButton *WxButton_Email;
        ////GUI Control Declaration End
		
	public:
		//Note: if you receive any error with these enum IDs, then you need to
		//change your old form code that are based on the #define control IDs.
		//#defines may replace a numeric value for the enum names.
		//Try copy and pasting the below block in your old form header files.
		enum
		{
			//// Controlli inerenti gli IDs dei forms, testi statici e pulsanti
			chiudi_prog = 1, content_prog = wxID_ABOUT, pulsante_stampa, stampa_form,
            button_save = 1010, apri_database = 1012, esci,
            ID_Larghezza = 1003,
			ID_WXSTATICTEXT1 = 1004, manda_email=124,
            ID_Risultato = 1002,
			ID_WXBUTTON1 = 1001, pulsante_somma, LboxTest_AddText, ID_WXEDIT3 = 1004, azzera_forms,
        	//// Fine controllo IDs
			ID_DUMMY_VALUE_ //don't remove this value unless you have other enum values
	
    	};
		
	public: // funzioni pubbliche...	
		void Chiudi_Frame_Principale(wxCloseEvent& event);
		void CreateGUIControls(void);
        void OnButtonAdd(wxCommandEvent& event);
        void Azzera_Forms(wxCommandEvent& event);
        void Chiudi_Programma(wxCommandEvent& event);
        void Content_Programma(wxCommandEvent& event);
        void saveText(wxCommandEvent& event);
        void Apri_DB(wxCommandEvent& event);
        void Stampa(wxCommandEvent& event);
        void Manda_Email(wxCommandEvent& event);
              
};


class Frame_Figlio : public wxDialog
{
public:
    Frame_Figlio(const wxString& title);    

private:
   
    DECLARE_EVENT_TABLE()

public:
       wxButton *Apri_DB;
       wxTextCtrl *Database;
       wxButton *Esci;
       wxButton *Stampa;
       wxButton *Email;

public:
       enum
		{
			//// Controllo degli IDs dei forms e dei pulsanti presenti nel frame
			apri_database = 10, campo_testo = 11, pulsante_uscita = 12, stampa_db=154, invia_mail_db
       
        };

public:    //// Funzioni pubbliche...
       void OnOpenFile(wxCommandEvent& event);
       void Chiudi_PopUp(wxCommandEvent& event);
       void Stampa_Database(wxCommandEvent& event);
       void Invia_Email_Database(wxCommandEvent& event);
};

 
class MyStringClass: public wxString 
{ 
public: 
        template <class T> bool From_String(T &aValue, const std::string &aStr);
        template <class T> std::string To_String(T aValue);  
        MyStringClass &operator + (const MyStringClass &o); 
}; 


template <class T>
bool MyStringClass::From_String(T &aValue, const std::string &aStr)
{   
   std::stringstream stringa(aStr); // aStr = stringa_input, il costruttore stringstream fa una copia di aStr
                                         //  senza modificarlo a tutti gli effetti!
   return stringa >> aValue;        // legge il contenuto di aValue, se  un int, lo legge come un int
}

template <class T>
std::string MyStringClass::To_String(T aValue)
{
   std::stringstream stringa;
   stringa << aValue;          // salva in "stringa" il contenuto di "aValue"...
   return stringa.str();
}

#if 0 // questa parte di codice non viene compilata, pu essere usata nel caso si voglia usare queste funzioni ovunque
// Template per gestire le stringhe in modo veloce e portabile!
// stringstream gestisce le stringhe come flussi di input/output
template <typename T>
bool From_String(T &aValue, const std::string &aStr)
{
   std::stringstream stringa(aStr); // aStr = stringa_input, il costruttore stringstream fa una copia di aStr
                                         //  senza modificarlo a tutti gli effetti!
   return stringa >> aValue;        // legge il contenuto di aValue, se  un int, lo legge come un int
}


template <typename T>
std::string To_String(T aValue)
{
   std::stringstream stringa;
   stringa << aValue;          // salva in "stringa" il contenuto di "aValue"...
   return stringa.str();
}
#endif
// Fine parte di codice a compilazione condizionata

#endif
